﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Microsoft.Practices.Unity.InterceptionExtension;
using Microsoft.Practices.Unity;

namespace CachingCallHandler4OutParam
{
    [AttributeUsage(AttributeTargets.Property | AttributeTargets.Method | AttributeTargets.Class)]
    public class FixedCachingCallHandlerAttribute : HandlerAttribute
    {
        // Fields
        private TimeSpan expirationTime;

        // Methods
        public FixedCachingCallHandlerAttribute()
        {
            this.expirationTime = FixedCachingCallHandler.DefaultExpirationTime;
        }

        public FixedCachingCallHandlerAttribute(int hours, int minutes, int seconds)
        {
            this.expirationTime = new TimeSpan(hours, minutes, seconds);
        }

        public override ICallHandler CreateHandler(IUnityContainer ignored)
        {
            return new FixedCachingCallHandler(this.expirationTime, base.Order);
        }
    }
}
